/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.5
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "ip_to_geo"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "ip_to_geo"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "0.1"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * ip_arg;	/**< @brief IP to convert.  */
  char * ip_orig;	/**< @brief IP to convert original value given at command line.  */
  const char *ip_help; /**< @brief IP to convert help description.  */
  int quiet_flag;	/**< @brief Quiet mode (default=off).  */
  const char *quiet_help; /**< @brief Quiet mode help description.  */
  int verbose_flag;	/**< @brief Verbose mode (default=off).  */
  const char *verbose_help; /**< @brief Verbose mode help description.  */
  int daemon_flag;	/**< @brief Daemonize (default=off).  */
  const char *daemon_help; /**< @brief Daemonize help description.  */
  int port_arg;	/**< @brief Port (default='53333').  */
  char * port_orig;	/**< @brief Port original value given at command line.  */
  const char *port_help; /**< @brief Port help description.  */
  char * bind_ip_arg;	/**< @brief IP to bind to.  */
  char * bind_ip_orig;	/**< @brief IP to bind to original value given at command line.  */
  const char *bind_ip_help; /**< @brief IP to bind to help description.  */
  int no_background_flag;	/**< @brief Don't go to background for daemon mode (default=off).  */
  const char *no_background_help; /**< @brief Don't go to background for daemon mode help description.  */
  int sockets_per_thread_arg;	/**< @brief Number of sockets managed by a single thread (default='10').  */
  char * sockets_per_thread_orig;	/**< @brief Number of sockets managed by a single thread original value given at command line.  */
  const char *sockets_per_thread_help; /**< @brief Number of sockets managed by a single thread help description.  */
  int sockets_timeout_arg;	/**< @brief Close connection after X seconds (default='5').  */
  char * sockets_timeout_orig;	/**< @brief Close connection after X seconds original value given at command line.  */
  const char *sockets_timeout_help; /**< @brief Close connection after X seconds help description.  */
  int client_max_requests_arg;	/**< @brief Number of requests allowed for one client (default='100').  */
  char * client_max_requests_orig;	/**< @brief Number of requests allowed for one client original value given at command line.  */
  const char *client_max_requests_help; /**< @brief Number of requests allowed for one client help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int ip_given ;	/**< @brief Whether ip was given.  */
  unsigned int quiet_given ;	/**< @brief Whether quiet was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int daemon_given ;	/**< @brief Whether daemon was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int bind_ip_given ;	/**< @brief Whether bind-ip was given.  */
  unsigned int no_background_given ;	/**< @brief Whether no-background was given.  */
  unsigned int sockets_per_thread_given ;	/**< @brief Whether sockets-per-thread was given.  */
  unsigned int sockets_timeout_given ;	/**< @brief Whether sockets-timeout was given.  */
  unsigned int client_max_requests_given ;	/**< @brief Whether client-max-requests was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
